function [gce_omst_graph,ind] = jgraph_threshold_max_gce_omst(A,flag)
% A is distence matrix
% A = graph_1;

A_left = A;
A_out = A;
A_out(A_out>0) = 0;


%GE_ini = efficiency_wei(A);
GE_ini = mean(global_efficiency_wd(1./A));
cost_ini = sum(A(:));

N = size(A,1);
m = N*(N-1)/2/(N-1);
    lastGCE = 0;
    GCE_temp = 0;
    nlower = 0;
for i=1:m
    G = graph(1./A_left);
    T = minspantree(G);
    mst_one = full(adjacency(T)).*A;
    A_out(mst_one>0) = mst_one(mst_one>0);
    A_left(mst_one>0)=0;

    % GE(i) = efficiency_wei(A_out);
    GE(i) = mean(global_efficiency_wd(1./A_out));
    cost(i) = sum(A_out(:)) / cost_ini;
    GCE(i) = (GE(i)/ GE_ini) - (cost(i));
    
    if GCE(i) > GCE_temp
        gce_omst_graph = A_out;
        ind = i;
        GCE_temp = GCE(i);
        nlower = 0;
    else
        nlower = nlower + 1;
    end

end

% [globalcosteffmax,ind] = max(GCE);
% gce_omst_graph =  A_outs{ind};
% costmax = cost(ind);
if(flag ==1)
figure(1),plot(cost,GCE,'.-'),hold on, plot(costmax,globalcosteffmax,'r*')
xlabel('Cost')
ylabel('Global Cost Efficiency')
title('Economical small-world network at max Global Cost Efficiency')
text(costmax,globalcosteffmax,'   \leftarrow OMST',...
     'HorizontalAlignment','left')
text(costmax,globalcosteffmax,num2str(ind),...
     'HorizontalAlignment','left') 
end