function gce_opmfg_graph = jgraph_threshold_max_gce_opmfg(A,flag)
% A is distence matrix
% A = graph;

A_left = A;
A_out = A;
A_out(find(A_out>0)) = 0;



% GE_ini = efficiency_wei(A);
GE_ini = mean(global_efficiency_wd(1./A));
cost_ini = sum(A(:));

% clear GE cost GCE
for i=1:7
    pmfg_one = full(pmfg(A_left));
    
    A_out(pmfg_one>0) = pmfg_one(pmfg_one>0);
    A_outs{i} = A_out;
    A_left(pmfg_one>0)=0;

%     GE(i) = efficiency_wei(A_out);
    GE(i) = mean(global_efficiency_wd(1./A_out));
    cost(i) = sum(A_out(:)) / cost_ini;
    GCE(i) = (GE(i)/ GE_ini) - (cost(i));
end

[globalcosteffmax,ind] = max(GCE);
gce_opmfg_graph =  A_outs{ind};
costmax = cost(ind);
if(flag ==1)
figure(1),plot(cost,GCE,'.-'),hold on, plot(costmax,globalcosteffmax,'r*')
xlabel('Cost')
ylabel('Global Cost Efficiency')
title('Economical small-world network at max Global Cost Efficiency')
text(costmax,globalcosteffmax,' \leftarrow OPMFG',...
     'HorizontalAlignment','left')
text(costmax,globalcosteffmax+0.02,num2str(ind),...
     'HorizontalAlignment','left') 
end