function gce_omst_graph = jgraph_threshold_max_gce_pmfg_omst(A,flag)
% A is distence matrix
% A = graph_1;

A_left = A;
A_out = A;
A_out(A_out>0) = 0;


GE_ini = efficiency_wei(A);
cost_ini = sum(A(:));

N = size(A,1);
m = N*(N-1)/2/(N-1);

pmfg_graph = full(pmfg(A));
A_out(pmfg_graph>0) = pmfg_graph(pmfg_graph>0);
A_left(pmfg_graph>0)=0;

for i=1:m
    G = graph(1./A_left);
    T = minspantree(G);
    mst_one = full(adjacency(T)).*A;
    
    A_out(mst_one>0) = mst_one(mst_one>0);
    A_outs{i} = A_out;
    A_left(mst_one>0)=0;

    GE(i) = efficiency_wei(A_out);
    cost(i) = sum(A_out(:)) / cost_ini;
    GCE(i) = (GE(i)/ GE_ini) - (cost(i));
end

[globalcosteffmax,ind] = max(GCE);
gce_omst_graph =  A_outs{ind};
costmax = cost(ind);
if(flag ==1)
figure(1),plot(cost,GCE,'.-'),hold on, plot(costmax,globalcosteffmax,'r*')
xlabel('Cost')
ylabel('Global Cost Efficiency')
title('Economical small-world network at max Global Cost Efficiency')
text(costmax,globalcosteffmax,'   \leftarrow pmfg+OMST',...
     'HorizontalAlignment','left')
text(costmax,globalcosteffmax,num2str(ind),...
     'HorizontalAlignment','left') 
end