function gce_graph = jgraph_threshold_max_gce(A,flag)

% A = graph_1;
A_left = A;
A_out = A;
A_out(A_out>0) = 0;

% GE_ini = efficiency_wei(A);
GE_ini = mean(global_efficiency_wd(1./A));
cost_ini = sum(A(:));

N = size(A,1);
m = N*(N-1)/2/(N-1);

thres_max = max(max(A));
step=thres_max/100;
thres=(0:step:thres_max);
% thres = sort(thres,'descend')
    lastGCE = 0;
    GCE_temp = 0;
    nlower = 0;

if(thres_max==0)
gce_graph = A
end

for i = 1:length(thres)

    A_out(A_out>0) = 0;
    A_out(A>thres(i)) = A(A>thres(i));

    GE(i) = mean(global_efficiency_wd(1./A_out));
    cost(i) = sum(A_out(:)) / cost_ini;
    GCE(i) = (GE(i)/ GE_ini) - (cost(i));

    if(i==1)
        gce_graph = A_out;
    end

    if GCE(i) >= GCE_temp
        gce_graph = A_out;
        ind = i;
        GCE_temp = GCE(i);
        nlower = 0;
    else
        nlower = nlower + 1;
    end

end


if(flag ==1)
figure(1),plot(cost,GCE,'.-'),hold on, plot(costmax,globalcosteffmax,'r*')
xlabel('Cost')
ylabel('Global Cost Efficiency')
title('Economical small-world network at max Global Cost Efficiency')
text(costmax,globalcosteffmax,'   \leftarrow GCE',...
     'HorizontalAlignment','left')
text(costmax,globalcosteffmax,num2str(ind),...
     'HorizontalAlignment','left') 
end